<?php
/*
Plugin Name: Easy Map Creator
Plugin URI: 
Description: Google Maps for Wordpress
Author: qrevo
Version: 2.0.3
Author URI: 

Copyright (c) 2009 qrevo.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

function sanit($var) {
	if(is_array($var)) {
		return array_map('sanit',$var);	
	} else {
		return wp_specialchars($var,3);	
	}
}

function az_maps($atts) {
  extract(shortcode_atts(array(
      'stat' => '',
      'width' => '450px',
      'height'=> '360px',
	  'latlng' => '',
	  'zoom' => '',
	  'mtype' => '',
      'markers'=> '',
      'title'=> '',
      'info'=> '',
	), $atts));

  $randid = uniqid();
  $margin = '0 auto 20px auto';
  $latlng = ltrim($latlng,"(");
  $latlng = rtrim($latlng,")");
  $latlng = sanit($latlng);
  $zoom = sanit($zoom);

  if($mtype === "satellite") {
		$mtype = "G_SATELLITE_MAP";
  } elseif($mtype === "hybrid") {
		$mtype = "G_HYBRID_MAP";
  } elseif($mtype === "terrain") {
		$mtype = "G_PHYSICAL_MAP";
  } else {
		$mtype = "G_NORMAL_MAP";
  }

  $markers = ltrim($markers,"(");
  $markers = rtrim($markers,")");
  $markers = explode(")(",$markers);
  $maekers = sanit($markers);
  $title = explode(";:",sanit($title));
  $info = explode(";:",sanit($info));

 if($stat==="true") {
	$colors = array("red","blue","green");
    for($i=0; $i<count($markers); $i++) {
        	$mks = $mks.str_replace(" ","",$markers[$i]).','.$colors[$i%count($colors)].$i.'|';
	}
	return $mks;

 } else {

$key = get_option('googlemaps_apikey');

echo 
<<<END
<script src="http://maps.google.com/maps?file=api&amp;v=2&amp;sensor=false&amp;key=$key"></script>
<script type="text/javascript">
//<![CDATA[

var physical_map = new GMapType(G_PHYSICAL_MAP.getTileLayers(),
						G_PHYSICAL_MAP.getProjection(),"Terrain");

jQuery(function() {
	if(GBrowserIsCompatible()) {

		var map = new GMap2(document.getElementById('map_$randid'));
		var home = new GLatLng($latlng);
		map.addMapType(physical_map);
		map.setCenter(home, $zoom);
		map.setMapType($mtype);
		map.addControl(new GLargeMapControl);
		map.addControl(new GMapTypeControl());

		function addMarker(point,text){
			var marker = new GMarker(point);
			GEvent.addListener(marker, "click", function() {
			marker.openInfoWindowHtml(text);
			});
			return marker;
		}		
END;

$mcount = count($markers);
for($MyCount=0; $MyCount<$mcount; $MyCount++) {
	if($markers[$MyCount]) {

echo
<<<END
		var point{$randid}_{$MyCount} = new GLatLng($markers[$MyCount]);
		map.addOverlay(addMarker(point{$randid}_{$MyCount},'<h4>$title[$MyCount]</h4>$info[$MyCount]'));
END;

	} 
} 

echo
<<<END
	}
});

window.onunload = GUnload;

//]]>
</script>
END;

return '<div id="map_'.$randid.'" style="margin:'.$margin.';width:'.$width.'px; height:'.$height.'px" class="azmaps"></div>';

 }

}
add_shortcode('azmaps', 'az_maps');



add_action('admin_footer','add_azmaps');

function add_azmaps(){

echo <<<EOT
	<script type="text/javascript">
	<!--
	jQuery("#add_media").after('<a class="thickbox" href="../wp-content/plugins/MapCreator/azmapform.php?KeepThis=true&TB_iframe=true&height=720&width=650">Map Creator</a>');
	-->
	</script>
EOT;
}



add_action('admin_menu', 'azmaps_menu');

function azmaps_menu() {
	add_options_page('Map Creator options', 'Easy Map Creator', 'administrator', __FILE__, 'azmaps_options');
}

function azmaps_options() {

?>
<div class="wrap">
	<h2>Map Creator Setting</h2>

<form method="post" action="options.php">
	<?php wp_nonce_field('update-options'); ?>

	<table class="form-table">

		<tr valign="top">
			<th scope="row">Google MAPS API Key</th>
			<td><input style="width:360px" type="text" name="googlemaps_apikey" value="<?php echo get_option('googlemaps_apikey'); ?>" /></td>
		</tr>

	</table>

	<input type="hidden" name="action" value="update" />
	<input type="hidden" name="page_options" value="googlemaps_apikey" />

	<p class="submit">
	<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
	</p>

</form>
</div>
<?php

}
?>
